code     segment  'code'
         assume   cs:code,ds:code
alt_q    equ      1000h
org      100h
start:   jmp      init
old_09h  dd       0
mesr     db       '<Aalt>/Q -reset',13,10
mesrlen  equ      $-mesr
boarders db       0,0,179,180,191,192,193,194,195,196,197,217,218
;
new_09h: cli
         pushf
         call     cs:old_09h
         push     ax
         push     bx
         push     cx
         push     dx
         push     bp
         push     ds
         push     es
         mov      ax,cs
         mov      ds,ax
         mov      ax,40h
         mov      es,ax
         mov      bx,es:1ah
         mov      ax,es:[bx]
         cmp      ax,alt_q
         je       altq
         cmp      ah,2
         jb       home
         cmp      ah,12
         ja       home
         test     byte ptr es:17h,40h
         jz       home
         push     bx
         lea      bx,boarders
         xchg     ah,al
         xlat
         pop      bx
         mov      byte ptr es:[bx],al
home:    pop      es
         pop      ds
         pop      bp
         pop      dx
         pop      cx
         pop      bx
         pop      ax
         sti
         iret
;
altq:    mov      ax,ds
         mov      es,ax
         mov      ah,13h
         mov      al,1
         mov      bx,0020h
         mov      cx,mesrlen
         mov      dh,16
         mov      dl,22
         mov      bp,offset mesr
         int      10h
;
         mov      ax,0
         mov      es,ax
         mov      ax,word ptr old_09h
         mov      word ptr es:24h,ax
         mov      ax,word ptr old_09h+2
         mov      word ptr es:26h,ax
         jmp      home
endres   equ      $-start
;
init:    mov      ax,3509h
         int      21h
         mov      word ptr old_09h,bx
         mov      word ptr old_09h+2,es
         mov      ax,2509h
         mov      dx,offset new_09h
         int      21h
         mov      dx,offset mes
         mov      ah,9
         int      21h
         mov      ax,3100h
         mov      dx,(endres+10fh)/16
         int      21h
mes      db       'new_09h set and stay in memory',10,13,'$'
code     ends
         end      start